/*
 * CompanyUsersView.java
 *
 * Created on 10 de agosto de 2004, 18:10
 */

package com.fenalco.servlets.supplier;

import java.io.IOException;

import javax.servlet.RequestDispatcher;
import javax.servlet.ServletConfig;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import com.fenalco.entities.User;
import com.fenalco.entities.UserList;
import com.fenalco.utilities.MessageBuilder;
import com.fenalco.utilities.lists.UserListView;

/**
 * Este servlet construye un listado de los usuarios internos de la empresa.
 * Esta información es enviada a <CODE>usuariosempresa.jsp</CODE>
 * 
 * @author andres
 */

public class CompanyUsersView extends HttpServlet
{

	/**
	 * Inicializa el servlet.
	 * 
	 * @param config
	 *            Parámetro de configuración del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de inicialización
	 */
	public void init( ServletConfig config ) throws ServletException
	{
		super.init(config);

	}

	/**
	 * Destruye el servlet.
	 */
	public void destroy( )
	{

	}

	/**
	 * Procesa las peticiones a los métodos HTTP <code>GET</code> y
	 * <code>POST</code>.
	 * 
	 * Este método construye un objeto <CODE>UserList</CODE> pasando como
	 * parámetro el identificador del proveedor. Este objeto a su vez se envía
	 * como parámetro para la construcción de un objeto <CODE>UserListView
	 * </CODE>.
	 * 
	 * En este objeto se encuentra encapsulada la información requerida por
	 * <CODE>usuariosempresa.jsp</CODE> que le será enviada como un atributo
	 * de response.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo enla operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response.
	 */
	protected void processRequest( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		HttpSession session = request.getSession(false);
		RequestDispatcher dispatcher;
		String url = "";
		String message = "";

	    try
	    {
	        if( session == null || ( User )session.getAttribute( "user" ) == null || ( ( User )session.getAttribute( "user" ) ).getRoleId() != 2 )
			{
				url = "/logout";
				//message = "Sesión no iniciada";
				message = MessageBuilder.buildMessage(15);
			}
			else
			{
				User supplier = (User) session.getAttribute("user");
				UserList userList = new UserList(supplier.getCompanyId());
				UserListView view = new UserListView(userList);
				if( view == null )
				{
					//Fallo en la creación de la lista de usuarios.
					//message = "Fallo en la creación de la lista de usuarios";
					message = MessageBuilder.buildMessage(9);
					url = "/proveedor/usuariosempresa.jsp";
				}
				else
				{
					//Todo OK
					//message = "La lista de usuarios de creó correctamente";
					//message = MessageBuilder.buildMessage(3);
					message = "";
					url = "/proveedor/usuariosempresa.jsp";
					request.setAttribute("view", view);
				}
			}
	
			if( request.getAttribute("message") != null )
			{
				message = (String) request.getAttribute("message");
			}
	    }
	    catch( Exception e )
	    {
	        url="/logout";
	        message = MessageBuilder.buildMessage(15);
	    }

		request.setAttribute("message", message);
		dispatcher = getServletContext().getRequestDispatcher(url);
		dispatcher.forward(request, response);
	}

	/**
	 * Maneja el método HTTP <code>GET</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response.
	 */
	protected void doGet( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Maneja el método HTTP <code>POST</code>.
	 * 
	 * @param request
	 *            Petición al servlet
	 * @param response
	 *            Respuesta del servlet
	 * @throws ServletException
	 *             Excepción de fallo en la operación de procesamiento de
	 *             peticiones
	 * @throws IOException
	 *             Excepción de fallo en la operación de escritura con el flujo
	 *             <CODE>PrintWriter</CODE> de response.
	 */
	protected void doPost( HttpServletRequest request,
			HttpServletResponse response ) throws ServletException, IOException
	{
		processRequest(request, response);
	}

	/**
	 * Información general del servlet.
	 * 
	 * @return Retorna descripción general del servlet
	 */
	public String getServletInfo( )
	{
		return "Short description";
	}

}